#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#define MAX_SIZE 1000

//progra oczekuje na wiadomość "Ejże!" i odsyła wiadomość "Hola hola!".
int main()
{
	char *buffer;
	char *message = "Ejże!";
	char *response = "Hola hola!";
	int shmid = shmget(0xABCD, MAX_SIZE, IPC_CREAT | 0660);
	if(shmid == -1)
	{
		perror("Błąd podczas tworzenia segmentu");
		return -1;
	}
	buffer = shmat(shmid, NULL, 0);	//tworzę kolejkę pod dowolnym adresem w pamięci wirtualnej procesu
	if(buffer == (char*)-1)	//rzutowanie na char* mówi kompilatorowi, że wiem co robię porównując wskaźnik z -1, przez co nie rzuca warninga.
	{
		perror("Błąd podczas podłączenia segmentu");
		return -1;
	}
	while( strncmp(buffer, message, strlen(message) ) != 0)
	{
		sleep(1);  //aktywne czekanie nie jest dobre, ale dla przykładu wystarcza.
	}
	printf("Otrzymałem wiadomość! %s\n", buffer);

	strncpy(buffer, response, strlen(response)+1);

	shmdt(buffer);
	return 0;
}
