#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/msg.h>
#define MAX_SIZE 1000

//program wysyła wiadomość "Ejże!" i czeka na odpowiedź "Hola hola!"
int main()
{
	char *buffer;
	char *message = "Ejże!";
	char *response = "Hola hola!";
	int shmid = shmget(0xABCD, MAX_SIZE, IPC_CREAT | 0660);
	
	if(shmid == -1)
	{	
		perror("Błąd podczas tworzenia segmentu");
		return -1;
	}
	buffer = shmat(shmid, NULL, 0);
	if(buffer == (char*)-1)
	{
		perror("Błąd podczas podłączenia segmentu");
		return -1;
	}

	strncpy(buffer, message, strlen(message)+1);
	
	while( strncmp(buffer, response, strlen(response) ) != 0)
	{
		sleep(1);
	}
	printf("Otrzymałem odpowiedź! %s\n", buffer);

	shmdt(buffer);

	shmctl(shmid, IPC_RMID, NULL); //Ta operacja jest bezpieczna - segment nie zostanie usunięty, dopóki wszystkie podłączone procesy nie wykonają shmdt
	
	printf("Ta instrukcja może wywołać naruszenie ochrony pamięci: %s\n", buffer); //po wykonaniu shmdt wskaźnik na buffer nie jest już poprawny

	return 0;
}
